Public Class CodeWriter

    Public Function WriteCode(ByVal refobj As ReferenceObj) As String
        Dim CodeOut As String

        Dim header, title, body, footer As String
        'If lang = BibleBrowser.BrowserLanguageStyle.English Then
        '    body = GenerateEnglishBodyText(refobj)
        '    header = "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\froman\fcharset0 Times New Roman;}{\f1\fnil\fcharset0 Times New Roman;}{\f2\fswiss\fcharset0 Arial;}}\viewkind4\uc1\pard\sb100\sa100"
        '    title = "\b\f0\fs36 " & BooksOfBible(CBook) & " " & CChapter & ":" & CVerse & "\b0\fs24\par "
        'ElseIf lang = BibleBrowser.BrowserLanguageStyle.Greek Then
        Dim i As Integer
        For i = 0 To refobj.NumberOfRefs
            If i = 0 Then
                body = GenerateBodyText(refobj, i)
            Else
                body &= GenerateBodyText(refobj, i)
            End If
        Next
        body &= GenerateNotes
        header = "{\rtf1\ansi\ansicpg1252\deff0\deflang1033\deflangfe1033{\fonttbl{\f0\froman\fprq2\fcharset0 Times New Roman;}{\f1\froman\fprq2\fcharset2 Symbol;}{\f2\fswiss\fprq2\fcharset0 Arial;}}\viewkind4\uc1\pard\nowidctlpar\sb100\sa100"
        title = "\b\f0\fs36 " & BooksOfBible(CBook) & " " & CChapter & ":" & CVerse & "\b0\fs24\par "
        'End If

        footer = " }"

        CodeOut = header & title & body & footer
        Return CodeOut
    End Function

    Function GenerateNotes() As String
        Dim filename As String = "00" & CBook & "x" & "00" & CChapter & "x" & "00" & CVerse & ".notes"
        Dim filepath As String = Application.StartupPath & "\Notes\" & filename
        If IO.File.Exists(filepath) Then
            Dim sr As New IO.StreamReader(filepath)
            Dim source As String = sr.readToend
            sr.Close()
            sr = Nothing
            Return "/p " & source
        Else
            Return ""
        End If
    End Function

    Private Function GenerateBodyText(ByVal refobj As ReferenceObj, ByVal index As Integer) As String
        Select Case refobj.RefLang(index)
            Case ReferenceObj.BrowserLanguageStyle.Greek
                Return GenerateGreekBodyText(refobj, index)
            Case ReferenceObj.BrowserLanguageStyle.English
                Return GenerateEnglishBodyText(refobj, index)
            Case ReferenceObj.BrowserLanguageStyle.Latin

            Case ReferenceObj.BrowserLanguageStyle.Other

        End Select
    End Function

    Private Function GenerateEnglishBodyText(ByVal refobj As ReferenceObj, ByVal index As Integer) As String
        On Error Resume Next

        Dim Refs As String = BooksOfBible(CBook) & " " & CChapter & ":" & CVerse

        Dim reftext As String

        reftext = "\f0 " & ReferenceLib.EngBibles(refobj.Refs(index)).Title & "\f0\line " & ReferenceLib.EngBibles(refobj.Refs(index)).GetVerse(Refs, CBook)

        Return reftext & "\par "
    End Function

    Private Function GenerateGreekBodyText(ByVal refobj As ReferenceObj, ByVal index As Integer) As String
        On Error Resume Next

        Dim ref As String
        ref = ReferenceLib.GrkBibles(refobj.Refs(index)).Books(CBook).GetReference(CChapter, CVerse)

        Dim ref2 As String

        Dim c As Integer
        Dim sOut As String
        Dim Brackets As Boolean = False
        Dim ParsingInfo As Boolean = False
        Dim Numbering As Boolean = False

        Brackets = False
        ParsingInfo = False
        Numbering = False
        For c = 0 To ref.Length - 1
            If Char.IsNumber(ref.Chars(c)) Then
                If GreekNumbers = False Then
                    If c > 5 Then

                    Else
                        If Parsing = False Then
                            If Brackets = False Then
                                ref2 &= ref.Chars(c)
                            End If
                        Else
                            ref2 &= ref.Chars(c)
                        End If
                    End If
                Else
                    If c > 5 Then
                        If ref.Chars(c - 1) = CChar(" ") Then
                            Numbering = True
                            '                                ref2 &= "<font color=" & ControlChars.Quote & "#336600" & ControlChars.Quote & " size=" & ControlChars.Quote & "-1" & ControlChars.Quote & ">"
                        End If
                    End If
                    If Parsing = False Then
                        If Brackets = False Then ref2 &= ref.Chars(c)
                    Else

                        ref2 &= ref.Chars(c)
                    End If
                End If
            ElseIf ref.Chars(c) = CChar("{") Then
                Brackets = True
                '                    If Parsing Then ref2 &= "<font color=" & ControlChars.Quote & "#330066" & ControlChars.Quote & "face=" & ControlChars.Quote & "Times New Roman, Times, serif" & ControlChars.Quote & " size=" & ControlChars.Quote & "-1" & ControlChars.Quote & "><em>{"
            ElseIf ref.Chars(c) = CChar("}") Then
                Brackets = False
                '                   If Parsing Then ref2 &= "}</em></font>"
            ElseIf ref.Chars(c) = CChar(" ") Then
                If Numbering Then
                    '                      ref2 &= "</font> "
                    Numbering = False
                Else
                    ref2 &= ref.Chars(c)

                End If
            Else
                If Parsing = False Then
                    If Brackets = False Then ref2 &= ref.Chars(c)
                Else
                    ref2 &= ref.Chars(c)
                End If
            End If

        Next
        ref2 = ref2.Replace("   ", " ")
        ref2 = ref2.Replace("  ", " ")
        ref2 = ref2.Insert(0, "\f0 " & ReferenceLib.GrkBibles(refobj.Refs(index)).Title & "\f1\line ")

        Return ref2 & "\par "

    End Function

End Class
